unit graphic;
interface



const
  HiPix= 50;

var
  exitf: boolean;

function klaf: boolean; {zoom, posun.....}
procedure draw;
procedure writeDta;
procedure closeg;
procedure iniGraph;

implementation

uses crt, graph, elasp;

const
  maxWord= 65535;
  minWord= 1;
  minInt= 0;
  XcenterScreen=320;
  YcenterScreen=240;
  Xmax=638;
  Ymax=479;
  colorka=lightGreen;
  drvPath='';
  zoom=400;
  ych1=100;
  ych2=200;
  ych3=300;
  ych4=400;

var
   scale: word;
   offset, OldOfs, CurX, Yoffset: longint;
   x, y: single;
   gm, gd: integer;
   key: byte;

function klaf: boolean; {zoom, posun.....}
var

  s: string;
begin
  klaf:= false;
  {if keypressed then begin}
    key:=byte(readkey); {pretypovani}
    klaf:= true;
    if (key=81) or (key=113) then exitf:= true; {exit flag}
  {end;}
  {center}
  if (chr(key)='C') or (chr(key)='c') then begin
    offset:=0;
    Yoffset:=0;
  end;
  if key= 0 then begin
    key:= byte(readkey);
    case key of
      72: if offset < maxInt-20 then offset:=offset+20;{sipa nahoru}
      80: if offset > 0 then offset:= offset-20;       {sipa dolu}

      77: if CurX < maxInt then inc(CurX);           {doprtava}
      75: if CurX > 0 then dec(CurX);                {doleva}
     (*
      71: if Yoffset < (maxInt-10) then Yoffset:= Yoffset + 10;{sipa nahoru}
      79: if Yoffset > 10 then Yoffset:= Yoffset - 10;{sipa dolu}
       *)
      81: if offset < (maxBuf+600) then offset:= offset + 600;{doprtava}
      83: if offset > 600 then offset:= offset - 600;{doleva}
    end;
  end
  else
    case key of
      45: if scale<maxWord then inc(scale);{zoom - } {klaf +}
      43: if scale>minWord then dec(scale);{zoom + } {klaf -}
    end;
end;

procedure draw; {uspora pameti :) - to var}
var
  i:longint;
begin
  offset:=0;
  oldOfs:=1;
  repeat
  setColor(black);
  {bar(0,ych1-1,640,ych1-hipix);}
  if offset<>oldOfs then begin
    cleardevice;

  OldOfs:=offset;
  setColor(white);
  line(0,ych1+1,640,ych1+1); { CH 1 }
  line(0,ych2+1,640,ych2+1); { CH 2 }
  line(0,ych3+1,640,ych3+1); { CH 3 }
  line(0,ych4+1,640,ych4+1); { CH 4 }

  setColor(lightGreen);
  for i:=1 to 600 do begin
    { CH1 }
    moveTo(i,ych1-(HiPix*logVal(i+offset-1,_CH1)));
    lineTo(i,ych1-(HiPix*logVal(i+offset,_CH1)));
    { CH2 }
    moveTo(i,ych2-(HiPix*logVal(i+offset-1,_CH2)));
    lineTo(i,ych2-(HiPix*logVal(i+offset,_CH2)));
    { CH3 }
    moveTo(i,ych3-(HiPix*logVal(i+offset-1,_CH3)));
    lineTo(i,ych3-(HiPix*logVal(i+offset,_CH3)));
    { CH4 }
    moveTo(i,ych4-(HiPix*logVal(i+offset-1,_CH4)));
    lineTo(i,ych4-(HiPix*logVal(i+offset,_CH4)));
  end;
  writeDta;
  end;
  klaf;
  until key=byte('q');
end;

procedure writeDta;
var
  s: string[20];
  out:string[40];
  tofs:real;
begin
  outTextXY(1, ych1-HiPix-10,'CH1');
  outTextXY(1, ych2-HiPix-10,'CH2');
  outTextXY(1, ych3-HiPix-10,'CH3');
  outTextXY(1, ych4-HiPix-10,'CH4');
  tofs:= TSD*offset;
  if tofs<1000 then begin
    str(tofs:3:2,out);
    out:='TimeOffset:'+out+'us';
    OutTextXY(5,5,out);
  end else
    if tofs<1000000 then begin
      tofs:=tofs/1000;
      str(tofs:3:2,out);
      out:='TimeOffset:'+out+'ms';
      OutTextXY(5,5,out);
    end else
     if tofs<1000000000 then begin
       tofs:=tofs/1000000;
       str(tofs:3:2,out);
       out:='TimeOffset:'+out+'s';
       OutTextXY(5,5,out);
    end;

end;

procedure iniGraph;
begin
  scale:=10;
  initGraph(gm, gd, drvPath);
  exitf:= false;
end;

procedure closeg;
begin
  closeGraph;
  writeln('exiting from lanXgraph...');
end;

end.





for i:=1 to 600 do begin
    { CH1 }
    moveTo(i,ych1-(HiPix*logVal(i+OldOfs-1,_CH1)));
    lineTo(i,ych1-(HiPix*logVal(i+OldOfs,_CH1)));
    { CH2 }
    moveTo(i,ych2-(HiPix*logVal(i+OldOfs-1,_CH2)));
    lineTo(i,ych2-(HiPix*logVal(i+OldOfs,_CH2)));
    { CH3 }
    moveTo(i,ych3-(HiPix*logVal(i+OldOfs-1,_CH3)));
    lineTo(i,ych3-(HiPix*logVal(i+OldOfs,_CH3)));
    { CH4 }
    moveTo(i,ych4-(HiPix*logVal(i+OldOfs-1,_CH4)));
    lineTo(i,ych4-(HiPix*logVal(i+OldOfs,_CH4)));
  end;