unit DISPLAY;


interface

procedure WriteStat;
procedure iniCmdDisplay;

implementation

uses crt,elasp;

var
  us1:string[20];

procedure iniCmdDisplay;
begin
  window(1,10,80,24);
end;

procedure WriteStat;
var
  cline:integer;
begin
  cline:=WhereY;
  window(1,1,80,9);
  textBackground(blue);
  clrscr;
  { status... }

  { trigger edge }
  gotoxy(1,1);
  write('TrigEdge: ');
  textColor(white);
  case trigEdge of
    _te_falling:write('f~\_');
    _te_rising: write('r_/~');
  else
    write('err??');
  end;
  textColor(lightGray);

  { trigger source }
  gotoxy(18,1);
  write('TrigSrc: ');
  textColor(white);
  case TrigSource of
    _ts_CH1:write('CH1');
    _ts_CH2:write('CH2');
    _ts_CH3:write('CH3');
    _ts_CH4:write('CH4');
   else
     writeln('err??');
  end;
  textColor(lightGray);

  { sample delay }
  gotoxy(32,1);
  str(SD,us1);
  write('SampDelay: ');
  textColor(white);
  write(us1+'us');
  textColor(lightGray);

  { true sample delay }
  gotoxy(50,1);
  str(TSD:3:2,us1);
  write('TSD: ');
  textColor(white);
  write(us1+'us');
  textColor(lightGray);

  { generator mode }
  gotoxy(1,2);
  str(TSD:5:2,us1);
  write('Generator: ');
  textColor(white);
  case Generator of
    0:write('Off');
    1:write('On');
  else
    write('err??');
  end;
  textColor(lightGray);

  { generator mode }
  gotoxy(18,2);
  write('Chanels: ');
  textColor(white);
  case NOT_CH of
    true:write('Inverted');
    false:write('Normal');
  end;

  textColor(lightGray);

  { logo }
  textColor(yellow);
  gotoxy(45,9);
  write(' Logic Analyser @ RS232 from Cyber');

  textColor(lightGray);
  textBackground(black);
  iniCmdDisplay;
  gotoxy(1,cline);
end;


end.